﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Data.OleDb;

namespace howto_datagrid_master_detail
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // Data adapters for loading data.
        private OleDbDataAdapter DaAddresses, DaTestScores;
    
        // The DataSet to hold the data.
        private DataSet StudentDataSet;

        // Load the data.
        private void Form1_Load(object sender, EventArgs e)
        {
            // Compose the connection string.
            string connect_string =
                "Provider=Microsoft.ACE.OLEDB.12.0;" +
                "Data Source=Contacts.mdb;" +
                "Mode=Share Deny None";

            // Create a DataAdapter to load the Addresses table.
            DaAddresses = new OleDbDataAdapter(
                "SELECT * FROM Addresses", connect_string);

            // Create a DataAdapter to load the Addresses table.
            DaTestScores = new OleDbDataAdapter(
                "SELECT * FROM TestScores", connect_string);

            // Create and fill the DataSet.
            StudentDataSet = new DataSet();
            DaAddresses.Fill(StudentDataSet, "Addresses");
            DaTestScores.Fill(StudentDataSet, "TestScores");

            // Define the relationship between the tables.
            DataRelation data_relation = new DataRelation(
                "Addresses_TestScores",
                StudentDataSet.Tables["Addresses"].Columns["ContactID"],
                StudentDataSet.Tables["TestScores"].Columns["ContactID"]);
            StudentDataSet.Relations.Add(data_relation);

            // Bind the DataGrid to the DataSet.
            dgContacts.DataSource = StudentDataSet;
        }

        // Save changes to the data.
        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            // Use a CommandBuilder to make the INSERT,
            // UPDATE, and DELETE commands as needed.
            OleDbCommandBuilder cb_addresses = new OleDbCommandBuilder(DaAddresses);
            OleDbCommandBuilder cb_testscores = new OleDbCommandBuilder(DaTestScores);

            // Update the database.
            try
            {
                DaAddresses.Update(StudentDataSet, "Addresses");
                DaTestScores.Update(StudentDataSet, "TestScores");
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }
    }
}
